from enum import Enum


class MMind2WebPrompt(str, Enum):
    INSTRUCTION_PROMPT = """Using the previous screenshots and actions as context, try to complete the following task:
Task: {task}

Previous screenshots and actions:
"""

    ASSISTANT_PROMPT_NORMALIZED_CLICK = """The action should be one of the following:
- click(0.XXX, 0.YYY)
- click(0.XXX, 0.YYY); type("content")

0.XXX and 0.YYY are the normalized coordinates of the click position on the screenshot. Example: click(0.254, 0.753)

What should be the next action to complete the task?
Action: """

    ASSISTANT_PROMPT_ABSOLUTE_CLICK = """The action should be one of the following:
- click(x, y)
- click(x, y); type("content")

In click(x, y), x is the number of pixels from the left edge and y the number of pixels from the top edge.
FYI, the screenshot resolution is {resolution}.

What should be the next action to complete the task?
Action: """

    ASSISTANT_PROMPT_ABSOLUTE_CLICK_UITARS = """The action should be one of the following:
- click(point='<point>x y</point>')
- click(point='<point>x y</point>'); type(content='xxx'); # Use escape characters \\', \\\", and \\n in content part to ensure we can parse the content in normal python string format. If you want to submit your input, use \\n at the end of content.

In click(point='<point>x y</point>'), x is the number of pixels from the left edge and y the number of pixels from the top edge.
FYI, the screenshot resolution is {resolution}.

What should be the next action to complete the task?
Action: """
